#ifndef __winLA_h__
#define __winLA_h__
#include "winLA0.h"
#include "winESC.h"
#include "math.h"
#define NAMETAB_SIZE 255

union Value{
	int    INT;          // ̂ƂASTR, NAM̂Ƃ
	double DBL;          // _̂Ƃ
	unsigned int INA[2]; // DBLł̃Vtgsp
	TCHAR CH[8];		 // DLM̂ƂZq
};
struct dtTokenData {
	int    type;        // FIN, DEC(OCT, HEX, DEC, CHR), FLT, STR, DLM, NAM
	union Value v;      // l
	TCHAR * str;		// NAM, STR̂ƂL
	struct dtTokenData *addr;
};
typedef struct dtTokenData tokenData;
typedef struct{
	TCHAR Name[256];    // O
	tokenData DT;
} nameTableData;
nameTableData NameTab[NAMETAB_SIZE];
int numNameTable=0;

int addNameTab(TCHAR DT[]){// O\ɖɒǉ
	int L=lstrlen(DT);
	if(L==0) return -1;
	lstrcpy(NameTab[numNameTable].Name,DT);
	NameTab[numNameTable].DT.type=UNDEF;
	NameTab[numNameTable].DT.v.INT=0;
	NameTab[numNameTable].DT.str=NULL;
	int i= numNameTable++;
	return i;
}
int regNameTab(TCHAR DT[]){// 
	int L=lstrlen(DT);
	if(L==0) return -1;
	lstrcpy(NameTab[numNameTable].Name,DT);
	NameTab[numNameTable].DT.type=UNDEF;
	NameTab[numNameTable].DT.v.INT=0;
	NameTab[numNameTable].DT.str=NULL;
	int i=0; while(lstrcmp(NameTab[i].Name, DT)!=0)i++;
	if(i>=numNameTable)numNameTable++;
	return i;
}
TCHAR *allocMove(int num, TCHAR str[]){//̈mۂƕ̓]
		TCHAR *r = (TCHAR *)calloc(num+1, sizeof(TCHAR));
		if(r!=NULL) for(int i=0;i<=num;i++) r[i]=str[i];
		return r;
}
int convOctal(TCHAR str[]){
	int r=0;
	for(int i=0; str[i]!=0;i++) r = r*8+str[i]-'0';
	return r;
}
int convHexa(TCHAR str[]){
	int r=0;
	for(int i=2; str[i]!=0;i++) 
		if(str[i]>='0' && str[i]<='9') r=r*16+str[i]-'0';
		else r=r*16+str[i]-'A'+10;
	return r;
}
int convDec(TCHAR str[]){
	int r=0;
	for(int i=0; str[i]!=0;i++) r=r*10+str[i]-'0';
	return r;
}
double convFlt(TCHAR str[]){
	long double r=0,frc=0.1;int i;
	for(i=0; str[i]!=0 && str[i]!='.' && str[i]!='E' ;i++) r=r*10+str[i]-'0';
	
	if(str[i]=='.')	for(i++; str[i]!=0 && str[i]!='E' ;i++,frc/=10) r += frc*(str[i]-'0');
	if(str[i]=='E'){
		i++;int flag=false; if(str[i]=='-') flag = true;
		i++;int e=0; 
		while(str[i]!=0){ e=e*10+str[i]-'0';i++;}
		if(flag) for(int k=0;k<e;k++)r/=10;
		else 	 
			for(int k=0;k<e;k++){
				if   (r<1.7976931348623157E+307L) r*=10;
				else {r=1.7976931348623157E+308L;break;}
			} 
	}
	return (double)r;
}
tokenData LA(LaData s){ // LAʂg[Nf[^𐶐

	tokenData r;TCHAR ch[256]; r.type=s.type;r.v.INT=0;r.str=NULL;
	if     (s.type==STR && s.ch[0]!=0) r.str = allocMove(r.v.INT=strESC(s.ch, ch),ch);
	else if(s.type==NAM) {r.v.INT=regNameTab(s.ch);r.str=NULL;} 
	else if(s.type==DLM) lstrcpy(r.v.CH, s.ch); 
	else if(s.type==OCT){r.v.INT=convOctal(s.ch); r.type=DEC;}
	else if(s.type==HEX){r.v.INT=convHexa(s.ch) ; r.type=DEC;}
	else if(s.type==DEC) r.v.INT=convDec(s.ch)  ; 
	else if(s.type==CHR){ESC(s.ch, ch); r.v.INT=(int)ch[0];    ; r.type=DEC;}
	else if(s.type==FLT) r.v.DBL=convFlt(s.ch);
    return r;
}
tokenData LA(){ return LA(LA0());}
#endif
